#include <avr/io.h>
#include "spi_eeprom.h"

#include "wait.h"


#define t_init  -1
#define t_ongoing 0
#define t_last  1

unsigned char transmit(unsigned char,int);
void endPacket();

void init_spi_master()
{
    
    sbi(DDRB,DD0);
    sbi(DDRB,DD1);
    sbi(DDRB,DD2);
    cbi(DDRB,DD3);
    outp((1 << SPE) | ( 1 <<MSTR) | (1 <<SPR0), SPCR);
    sbi(PORTB,PORT0);
  
}

unsigned char transmit(unsigned char a,int t_type)
{
    unsigned char ret;
    ret = 0;
    if (t_type == t_init) 	{cbi(PORTB,PORT0);
    wait_ns(125);
   } 
    
    outp(a,SPDR);
       
    while(bit_is_clear(SPSR,SPIF)) {}
   ret = inp(SPDR);
//       uart_putchar(ret+(unsigned char)48); 
    //uart_putstr("<<<\r\n"); 
    if (t_type == t_last) {
	endPacket();
	
    }
	
    return ret;
	
}

void endPacket()
{
    sbi(PORTB,PORT0);
	wait_ns(250);
}


unsigned char readEeprom(unsigned int address)
{
    unsigned char ret;
    transmit(EEPROM_READOPCODE,t_init);
    transmit(((address >> 8) & 0xff),t_ongoing);
    transmit((address & 0xff),t_ongoing);
    ret = transmit(EEPROM_NOOP,t_last);
    return ret;
}

char  writeEeprom(unsigned int address, unsigned char data)
{
    transmit(EEPROM_WRENOPCODE,t_init);
    endPacket();
    transmit(EEPROM_WRITEOPCODE,t_init);
    transmit(((address >> 8) & 0xff),t_ongoing);
    transmit((address & 0xff),t_ongoing);
    transmit(data,t_last);
}

