
#include "twi.h"
#include <avr/io.h>
#include <avr/twi.h>
#include <stdlib.h>

#include <avr/interrupt.h>
#include <avr/signal.h>
#include "global.h"
#include "uart.h"


void setAddress();

unsigned char maddress;
int mgeneral;
recieve recvFunc;
rts rtsFunc;

struct twi_packet * recvpacket;
struct twi_packet * xmitpacket;

unsigned char currxmitpointer;
unsigned char xmitdone;
int counter;
unsigned char slave_address;
unsigned char getStatus();

unsigned char maxpacketlength;
unsigned char currlength;

unsigned char getStatus()
{
    return (inp(TWSR) & 0xf8);
}



void setRecieveFunc(recieve rec)
{
    recvFunc = rec;
}

void setRTSFunc(rts tosend)
{
    rtsFunc = tosend;
}

SIGNAL (SIG_2WIRE_SERIAL)
{

    char isxmitdone;
    char addy;
	unsigned char val_TWCR;
    unsigned char currStatus;
	addy =-1;
	isxmitdone=0;
	counter++;
	val_TWCR = (1 << TWINT) | (1 << TWEN) | (1 << TWIE);
	outp(0xff,DDRG);
	outp(counter,PORTG);
	

	    
   
    currStatus = getStatus();
	 //cbi(TWCR,TWIE);     
 
    
    #ifdef DEBUG 
    /*
			
			  	
			 //    uart_putchar(xmitpacket->to+48);
			     
			     
			     uart_putstr("\r\n--curr status :");
	    
	      uart_putstr("\r\n--\r\n");
	
     uart_putstr("\r\nIRQ\r\n");
      uart_putchar(currStatus+60);its 
	  
	  */
	 outp(0xff,DDRC);
     outp(0x00,PORTC);
     outp(currStatus,PORTC);
     
	      #endif
    
    
	if (currStatus ==  TW_SR_SLA_ACK) {
	    recvpacket = (struct twi_packet *)malloc(sizeof(struct twi_packet));
	    recvpacket->data = (char *)malloc(maxpacketlength * sizeof(char));
	    recvpacket->packet_type = TWI_SLAVE_RECV;
		  val_TWCR |= (1 << TWEA);
	    #ifdef DEBUG
	 //   	uart_putstr("SLA_ACK\r\n");
	    #endif
	    	
	}
	
	else if(currStatus == TW_SR_DATA_ACK) {
	    
	  *(recvpacket->data + currlength) = inp (TWDR);
	  #ifdef DEBUG
	 // 	uart_putstr("data \r\n");
	//	uart_putchar(inp(TWDR));
	  #endif
		
	  currlength ++ ;
	  if (currlength > maxpacketlength)
	  {
	      recvpacket->packet_type |= TWI_OVERFLOW;
	      recvpacket->length = currlength;
	     #ifdef DEBUG
	    //  	uart_putstr("OVERFLOW!! AAAAAA \r\n");
	      #endif

	      recvFunc(recvpacket);
      	      currlength = 0;
      
	  }
	    val_TWCR |= (1 << TWEA);
      }
	  
	  else if(currStatus == TW_SR_STOP) {
	      
	      #ifdef DEBUG
	     // 	uart_putstr("got stop condition \r\n");
	      #endif
	      recvFunc(recvpacket);
	      free(recvpacket);
	      currlength = 0;
		  inp(TWDR);
		  setAddress();
		  val_TWCR |= (1 << TWEA);
	  }
	
	else if (currStatus ==  TW_START || currStatus == TW_REP_START) {
	     #ifdef DEBUG
	   //   	uart_putstr("start\r\n");
	//	uart_putstr("packet type is :");
	//	uart_putchar(xmitpacket->packet_type);
		
	    #endif
		
	   // cbi(TWCR,TWSTA);
	      
	      if (xmitpacket->packet_type & TWIS_MSTR_READSLAVE) {
		addy = (xmitpacket->to) << 1 | 1;

	      }
	      else if (xmitpacket->packet_type & TWIS_MSTR_WRITESLAVE) {
		  addy = ((xmitpacket->to) << 1) & 0xfe;
		  #ifdef DEBUG 
		  outp(0xff,DDRF);
		  outp(addy,PORTF);
		  
		  	//uart_putstr("writing SLAW\r\n");
		//	uart_putchar(addy+48);
			
			#endif
		  
		  
	      }
	      #ifdef DEBUG
	      /*uart_putstr("sent to :");
	      
	      uart_putchar(addy+48);
	      uart_putstr("\r\n--\r\n");
	      uart_putchar(xmitpacket->to+48);
	      uart_putstr("\r\n--\r\n");
		  */
	      #endif
	      outp(addy,TWDR);
	      
	  }
	  
	
	else if(currStatus ==  TW_MT_SLA_ACK ) {
	      #ifdef DEBUG
	      //	uart_putstr("MT_SLA_ACK\r\n");
		//uart_putchar(*(xmitpacket->data) + 60);
	      #endif
	        
	      outp(*(xmitpacket->data),TWDR);
	      
	      currxmitpointer++;
	  }
	else if(currStatus == TW_MT_DATA_NACK) {
		currxmitpointer--;
		if (  currxmitpointer < xmitpacket->length) {
		  outp(*(xmitpacket->data + currxmitpointer),TWDR);
		  currxmitpointer++;
		}
		}
		
	
	else if(currStatus == TW_MT_DATA_ACK) {
	      #ifdef DEBUG
	      //	uart_putstr("MT_DATA_ACK\r\n");
		#endif
		
	      if (  currxmitpointer < xmitpacket->length) {
		  outp(*(xmitpacket->data + currxmitpointer),TWDR);
		  currxmitpointer++;
	      }
	      else {
		  isxmitdone=1;
		  #ifdef DEBUG
		  //uart_putstr("Releasing xmitpacket");
		  #endif
		 // free(xmitpacket);
		  val_TWCR |= (1 << TWSTO);
		  
	      }
	  
	
	      
		  
		  
		  
	      
      }
	  else {
	  		val_TWCR = 0; 
			}
			
	
    //sbi(TWCR,TWIE);
    outp(val_TWCR,TWCR);
	if (isxmitdone) {
		//wait_ns(100000);
		xmitdone =1;
	}
	
 #ifdef DEBUG
    //	uart_putstr("IRQExit\r\n");
	#endif
    
	
}
/*

void twi_init_master()
{

    outp(3,TWSR);
   outp(0,DDRD);
  outp(0x00,PORTD);

    
    outp(255,TWBR); // set bitrate to 15
   outp(3,TWSR); // prescale 3

    outp((1 << TWEN),TWCR);
	 
    
  
    
    }
    */


void twi_init(unsigned char address,int general,unsigned char bitrate,unsigned char mpl)
{
    unsigned char val_TWCR=0;
	counter=0;
  
	maddress = address;
	mgeneral = general;
		
    maxpacketlength = defaultmaxpacketlength;
    if (mpl > 0)  maxpacketlength = mpl;
	
	
    currlength=0;
    currxmitpointer=0;
    xmitdone=0;
    val_TWCR = (1 << TWEN) | (1 << TWIE);
    outp(0,DDRD);
    outp(0x00,PORTD);
       
    outp(bitrate,TWBR);
    outp(3,TWSR);
	setAddress();
	if (address > 0 ) {
		val_TWCR |= (1 << TWEA);
	}
    outp(val_TWCR,TWCR); 
}

void setAddress()
{
	unsigned char addyman;
	if (maddress > 0 ) {
    addyman = (maddress  << 1) | (mgeneral ==1);
    #ifdef DEBUG
   // 	uart_putstr("Setting address :");
	//uart_putchar(48+address);
	#endif
    outp(addyman,TWAR);
	}
}


char twi_write(struct twi_packet * xmit,int block)
{
    xmitpacket  = xmit;
    #ifdef DEBUG
  /*  uart_putstr("xmit data: ");
    uart_putchar(*(xmitpacket->data) + 50);
    
/*    uart_putstr(" xmit says :");
    uart_putchar(xmit->to + 48);
    uart_putstr(" \r\n xp :");
    uart_putchar(xmitpacket->to + 48);
    uart_putstr("\r\nyeah\r\n");
  */  
    #endif
    currxmitpointer=0;
    xmitdone=0;
    //cbi(TWCR,TWEA);
    //sbi(TWCR,TWSTA);  // send start condition
	outp((1 << TWEN) | (1 << TWINT) | (1 << TWSTA) | (1 << TWIE),TWCR);
	

    if (block > 0) {
	while (!xmitdone) {}
    }
    xmitdone=0;
    return 0;
    //loop_until_bit_is_set(TWCR,TWINT);
        
}



       
       

    
/*
void twi_init_slave(unsigned char address,char general)
{
   outp(0,DDRD);
    outp(0x00,PORTD);
    slave_address = address;
    address = ((address <<1)  & 0xff) | 0x01;
    /*outp(100,TWBR);
    outp(0,TWSR);
    
    uart_putchar(48+address);
    outp(address,TWAR);
    outp((1 << TWEN) | (1 << TWEA) | (1<<TWIE), TWCR);
/*
    if (general > 0) {
	sbi(TWAR,0);outp(0xff,DDRC);
     outp(0x00,PORTC);
     outp(currStatus,PORTC);
     
    }
    else  cbi(TWAR,0);
  */  
    
    /*
    uart_putstr("Done init\r\n");
    uart_putchar(48+(unsigned char)inp(TWAR));
	
    sei();

}

*/
    /*

unsigned char slave_blocked_read()
{
    unsigned char val_TWSR;
    unsigned char val_SPDR;
    loop_until_bit_is_set(TWCR,TWINT);

    //    uart_putchar(getStatus()
    if (getStatus() == SR_ADDRESS) {
	

	while (getStatus() != SR_DATA_ACK) {} // chill out while data comes in.
	val_SPDR = inp(SPDR);
    }
    return val_SPDR;
}
*/
	

	

    
/*
char twi_write(unsigned char address,unsigned char * data)
{
    
    unsigned char val_TWSR;
    unsigned char val_TWCR;
   uart_putstr("yo\r\n");
    
    val_TWCR = (1 << TWEN) | (1<<TWSTA) | (1 << TWINT);
    outp(val_TWCR,TWCR);
  //  sbi(TWCR,TWSTA); // send start conditon to become a master.
  //  uart_putstr("after\r\n");
    loop_until_bit_is_set(TWCR,TWINT);
    val_TWSR = getStatus();
    if (val_TWSR != MT_START) 
    {
	uart_putstr("screwed up start \r\n");
	cbi(TWCR,TWSTA);
	sbi(TWCR,TWINT);
	
//	cbi(TWCR,TWEN);
//	sbi(TWCR,TWEN);
	
	return -1 * val_TWSR;
    }
 	uart_putstr("START\r\n");
	
    address = (address << 1 ) & 0xfe;
    uart_putchar(48+address);
   outp(address,TWDR);
    uart_putchar(48+bit_is_set(TWCR,TWINT));
//    outp(val_TWCR,TWCR);
    val_TWCR = (1 << TWINT) | (1 << TWEN);
    outp(val_TWCR,TWCR);
  //  sbi(TWCR,TWINT); // clear interrupt to send slave address
    uart_putchar(48+bit_is_set(TWCR,TWINT));
    loop_until_bit_is_set(TWCR,TWINT);
        uart_putchar(48+bit_is_set(TWCR,TWINT));
    val_TWSR = getStatus();
    uart_putchar(48+val_TWSR);
    if (val_TWSR != MT_SLA_ACK) {
	uart_putstr("screwed up SLAW \r\n");
	cbi(TWCR,TWSTA);
	sbi(TWCR,TWINT);
	cbi(TWCR,TWEN);
	return -1 *(char) val_TWSR;
    }
 
    uart_putstr("SLA_ACK\r\n");
    
    outp(data,TWDR);
    outp(val_TWCR,TWCR);
//    sbi(TWCR,TWINT);
    loop_until_bit_is_set(TWCR,TWINT);
    val_TWSR = getStatus();
    
    if (val_TWSR != MT_DATA_ACK) {
	return -1 * (char)val_TWSR;
    }
    uart_putstr("DATA_ACK\r\n");
    
    val_TWCR = val_TWCR | (1 << TWSTO);
    TWCR = val_TWCR;
    
    return 0;
 
}
*/
    
	
    
    
    
    
    
    
