/*
    Title:    UART library
    Author:   Volker Oth
    Date:     5/1999
    Purpose:  Sending a block of data to uart.
    needed
    Software: AVR-GCC to compile, AVA to assemble and link
    needed
    Hardware: ATS90S8515 on STK200 board
    Note:     To contact me, mail to
                  volkeroth@gmx.de
              You might find more AVR related stuff at my homepage:
                  http://members.xoom.com/volkeroth
*/

#ifndef UART_H
#define UART_H

/* set baud rate here */
#define UART_BAUD_RATE 9600
#define ESC            0x1b
#define UART_BUF_SIZE    128

typedef void (*signal)(int status);
typedef void (*sig_newline)(unsigned char *);

#define UART_STAT_WATCH 21

/* automatically calcuate baud register value */
#define UART_BAUD_SELECT 51


/* prototypes */
extern void uart_init(void);
extern void uart_clr(void);
extern void uart_nl(void);
extern bool uart_putchar(u08 c);
extern s16  uart_getchar(void);
extern bool uart_putstr(u08 s[]);
void uart_setSignalHandler(signal);
void uart_watchFor(char watch);
void uart_setWatchEnable(unsigned char a);
void uart_setNewlineSignalHandler(sig_newline s);
void uart_setNewlineSignalEnable(unsigned char);


#endif 
